﻿using Android.App;
using Android.OS;
using Android.Support.V7.App;
using Android.Runtime;
using Android.Widget;
using Android.App.Admin;
using Android.Content;
using Android.Support.V4.Content;
using Android;
using Android.Content.PM;

namespace App34
{
    [Activity(Label = "@string/app_name", Theme = "@style/AppTheme", MainLauncher = true)]
    public class MainActivity : AppCompatActivity
    {
        protected static int REQUEST_ENABLE = 1;
        DevicePolicyManager deviceManger;
        ActivityManager activityManager;
        ComponentName compName;
        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.activity_main);

            if (ContextCompat.CheckSelfPermission(this, Manifest.Permission.BindDeviceAdmin) != (int)Permission.Granted)
            {
                RequestPermissions(new string[] { Manifest.Permission.BindDeviceAdmin }, 0);
            }

            Button buttonlock = FindViewById<Button>(Resource.Id.buttonlock);
            buttonlock.Click += Buttonlock_Click;

            deviceManger = (DevicePolicyManager)GetSystemService(Context.DevicePolicyService);
            activityManager = (ActivityManager)GetSystemService(Context.ActivityService);
            compName = new ComponentName(this, Java.Lang.Class.FromType(typeof(AdminReceiver)));

            Intent intent = new Intent(DevicePolicyManager.ActionAddDeviceAdmin);
            intent.PutExtra(DevicePolicyManager.ExtraDeviceAdmin, compName);
            intent.PutExtra(DevicePolicyManager.ExtraAddExplanation,this.GetString(Resource.String.sample_device_admin_description));
            StartActivityForResult(intent, REQUEST_ENABLE);



            // Launch the activity to have the user enable our admin.
           // Intent intent = new Intent(DevicePolicyManager.ACTION_ADD_DEVICE_ADMIN);
            //intent.putExtra(DevicePolicyManager.EXTRA_DEVICE_ADMIN, deviceAdminSample);
            //intent.putExtra(DevicePolicyManager.EXTRA_ADD_EXPLANATION,
            //        activity.getString(R.string.add_admin_extra_app_text));
            //startActivityForResult(intent, REQUEST_CODE_ENABLE_ADMIN);

        }
        
        private void Buttonlock_Click(object sender, System.EventArgs e)
        {
            // DevicePolicyManager dpm =(DevicePolicyManager)GetSystemService(Context.DevicePolicyService);
            bool active = deviceManger.IsAdminActive(compName);
            if (active)
            {
                deviceManger.LockNow();
            }
            Finish();
        }
        protected override void OnActivityResult(int requestCode, Result resultCode, Intent data)
        {
            if (REQUEST_ENABLE == requestCode)
            {
                base.OnActivityResult(requestCode, resultCode, data);
            }
        }
        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }
    }
}